blog/urls.py
from django.urls import path
from . import views

app_name = "blog"

urlpatterns = [
    path('', views.home, name="Home"),
    path('home/<int:page>', views.home, name="Home"),
    path('Post/<str:slug>', views.showpost, name="singlePost"),


]

resumeProject/urls.py
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import path , include
from . import settings

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('blog.urls')),
]

if settings.DEBUG:
    # static url
    urlpatterns = urlpatterns + static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)
    # media url
    urlpatterns = urlpatterns + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

blog/models.py
import os
import random

from django.db import models
from django.utils import timezone

from extenctions.utils import jalali_converter


def get_filename_ext(filepath):  # get name snd ext from file path
    basename = os.path.basename(filepath)
    name, ext = os.path.splitext(basename)
    return name, ext


def set_image_path(instance, filename):
    new_name = random.randint(1, 23654512156786)
    name, ext = get_filename_ext(filename)
    final_name = f"{new_name}{ext}"
    return f"Post/{instance.title}/image/{final_name}"


def set_file_path(instance, filename):
    new_name = random.randint(1, 23654512156786)
    name, ext = get_filename_ext(filename)
    final_name = f"{new_name}{ext}"
    return f"Post/{instance.post.title}/file/{final_name}"


class Post(models.Model):
    STATUS_CHOICES = (
        ("d", "پیش نویس"),
        ("p", "منتشر شده")
    )
    title = models.CharField(verbose_name="عنوان", max_length=80, unique=True)
    slug = models.SlugField(verbose_name="اسلاگ", allow_unicode=True, max_length=80)
    body = models.TextField(verbose_name="متن", )
    publish = models.DateTimeField(verbose_name="تاریخ انتشار", default=timezone.now)
    create = models.DateTimeField(verbose_name="تاریخ به وجود آمدن", auto_now_add=True)
    update = models.DateTimeField(verbose_name="تاریخ اصلاح", auto_now=True)
    status = models.CharField(verbose_name="وضعیت", choices=STATUS_CHOICES, max_length=1)
    image = models.ImageField(verbose_name="تصویر", upload_to=set_image_path)
    category = models.ForeignKey('Category', on_delete=models.CASCADE, verbose_name="دسته بندی",
                                 related_name='category_post',null=True)
    hashtag = models.ManyToManyField('Hashtag', verbose_name="برچسب(ها)",null=True)

    class Meta:
        verbose_name = "مطلب"
        verbose_name_plural = "مطالب"

    def __str__(self):
        return self.title

    def jpublish(self):
        return jalali_converter(self.publish)

    jpublish.short_description = "تاریخ انتشار"


class PostImage(models.Model):
    post = models.ForeignKey('Post', on_delete=models.CASCADE, related_name="Image_Post")
    image = models.ImageField(upload_to=set_image_path)


class PostFile(models.Model):
    post = models.ForeignKey('Post', on_delete=models.CASCADE, related_name="File_Post")
    file = models.ImageField(upload_to=set_file_path)


class Hashtag(models.Model):
    title = models.CharField(verbose_name="عنوان", max_length=50, unique=True)
    slug = models.SlugField(verbose_name="اسلاگ", allow_unicode=True)
    allow_to_show = models.BooleanField(verbose_name="آیا نمایش داده شود؟", default=False)

    class Meta:
        verbose_name = "برچسب"
        verbose_name_plural = "برچسب ها"

    def __str__(self):
        return self.title


class Category(models.Model):
    parent = models.ForeignKey('self', default=None, on_delete=models.SET_NULL, blank=True, related_name='children',
                               verbose_name="زیر دسته",null=True)
    name = models.CharField(max_length=30, verbose_name="عنوان", unique=True)
    slug = models.SlugField(allow_unicode=True)

    class Meta:
        verbose_name = "دسته بندی"
        verbose_name_plural = "دسته بندی ها"

    def __str__(self):
        return self.name

    def getLastPost(self):
        return self.category_post.all()[:4]

blog/views.py
from django.core.paginator import Paginator
from django.shortcuts import render, get_object_or_404

from blog.models import Post, Category

context = {}


def home(request, page=1):
    allPost = Post.objects.filter(status="p").order_by("-publish")
    mainPost = Paginator(allPost, 5)
    context["lastPage"] = mainPost.num_pages
    context["postMain"] = mainPost.get_page(page)

    context["myPost"] = Category.objects.get(name__exact="دست نوشته")
    return render(request, "public/index.html",context)


def showpost(request,slug):
    context["post"] = get_object_or_404(Post,slug=slug)
    return render(request,"public/single.html",context)

templates/base.html
{% load coustum %}
<!--
Author: W3layouts
Author URL: http://w3layouts.com
License: Creative Commons Attribution 3.0 Unported
License URL: http://creativecommons.org/licenses/by/3.0/
-->
<!DOCTYPE html>
<html>
<head>
    <title>مرجع تخصصی برنامه نویسان</title>

    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
    <meta name="keywords" content="Express News Responsive web template, Bootstrap Web Templates, Flat Web Templates, Andriod Compatible web template,
Smartphone Compatible web template, free webdesigns for Nokia, Samsung, LG, SonyErricsson, Motorola web design"/>

    {% include "share/css.html" %}
    {% include "share/js.html" %}

</head>
<body>
<!-- header-section-starts-here -->
{% header %}
<!-- header-section-ends-here -->
<div class="wrap">
    <div class="move-text" dir=ltr>
        <div class="breaking_news">
            <h2>آخرین اخبار</h2>
        </div>
        <div class="marquee">
            <div class="marquee1"><a class="breaking" href="single.html">>>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم
                از صنعت چاپ و با استفاده از طراحان گرافیک است..</a></div>
            <div class="marquee2"><a class="breaking" href="single.html">>>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم
                از صنعت چاپ و با استفاده از طراحان گرافیک است..</a></div>
            <div class="clearfix"></div>
        </div>
        <div class="clearfix"></div>
        <script>
            $('.marquee').marquee({pauseOnHover: true});
            //@ sourceURL=pen.js
        </script>
    </div>
</div>
<!-- content-section-starts-here -->
<div class="main-body">
    <div class="wrap">
        <div class="col-md-8 content-right">
            {% block content %}
            
            {% endblock %}
        </div>
        <div class="col-md-4 side-bar">
            {% leftbar %}
{#        ÷÷÷÷÷÷÷÷÷÷÷÷÷÷÷÷÷÷÷÷÷÷÷÷÷÷÷÷÷÷÷÷÷÷÷÷#}
        </div>
        <div class="clearfix"></div>
    </div>
</div>
<!-- content-section-ends-here -->

{% include "share/footer.html" %}

<a href="#to-top" id="toTop" style="display: block;"> <span id="toTopHover" style="opacity: 1;"> </span></a>
<!---->
</body>
</html>

templates/share/css.html
{% load static %}
<link href="{% static "css/bootstrap.css" %}" rel='stylesheet' type='text/css' />
<link href="{% static "css/style.css" %}" rel="stylesheet" type="text/css" media="all" />

<link href='//fonts.googleapis.com/css?family=Open+Sans:400,300,300italic,400italic,600,600italic,700,700italic,800,800italic' rel='stylesheet' type='text/css'>
<link href='//fonts.googleapis.com/css?family=Varela+Round' rel='stylesheet' type='text/css'>

templates/share/footer.html
	<div class="footer">
		<div class="footer-top">
			<div class="wrap">
				<div class="col-md-3 col-xs-6 col-sm-4 footer-grid">
					<h4 class="footer-head">درباره ما</h4>
					<p>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</p>
					<p>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد</p>
				</div>
				<div class="col-md-2 col-xs-6 col-sm-2 footer-grid">
					<h4 class="footer-head">دسته بندی</h4>
					<ul class="cat">
						<li><a href="business.html">تجارت</a></li>
						<li><a href="technology.html">تکنولوژی</a></li>
						<li><a href="entertainment.html">سرگرمی</a></li>
						<li><a href="sports.html">ورزشی</a></li>
						<li><a href="shortcodes.html">بهداشت و درمان</a></li>
						<li><a href="fashion.html">مد</a></li>
					</ul>
				</div>
				<div class="col-md-4 col-xs-6 col-sm-6 footer-grid">
					<h4 class="footer-head">لورم ایپسوم</h4>
					<ul class="flickr">
						<li><a href="#"><img src="images/bus4.jpg"></a></li>
						<li><a href="#"><img src="images/bus2.jpg"></a></li>
						<li><a href="#"><img src="images/bus3.jpg"></a></li>
						<li><a href="#"><img src="images/tec4.jpg"></a></li>
						<li><a href="#"><img src="images/tec2.jpg"></a></li>
						<li><a href="#"><img src="images/tec3.jpg"></a></li>
						<li><a href="#"><img src="images/bus2.jpg"></a></li>
						<li><a href="#"><img src="images/bus3.jpg"></a></li>
						<div class="clearfix"></div>
					</ul>
				</div>
				<div class="col-md-3 col-xs-12 footer-grid">
					<h4 class="footer-head">تماس با ما</h4>
					<span class="hq">لورم ایپسوم یا طرح‌نما</span>
					<address>
						<ul class="location">
							<li><span class="glyphicon glyphicon-map-marker"></span></li>
							<li>لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است</li>
							<div class="clearfix"></div>
						</ul>
						<ul class="location">
							<li><span class="glyphicon glyphicon-earphone"></span></li>
							<li>+0 561 111 235</li>
							<div class="clearfix"></div>
						</ul>
						<ul class="location">
							<li><span class="glyphicon glyphicon-envelope"></span></li>
							<li><a href="">info@barnamenevisan.org</a></li>
							<div class="clearfix"></div>
						</ul>
					</address>
				</div>
				<div class="clearfix"></div>
			</div>
		</div>
		<div class="footer-bottom">
			<div class="wrap">
				<div class="copylefts col-md-6">
					<p>کپی رایت@2015 تمام حقوق مادی و معنوی این سایت متعلق به گروه برنامه نویسان میباشد<a href="http://www.barnamenevisan.org">برنامه نویسان آینده ساز</a></p>
				</div>
				<div class="footer-social-icons col-md-6">
					<ul>
						<li><a class="facebook" href="#"></a></li>
						<li><a class="twitter" href="#"></a></li>
						<li><a class="flickr" href="#"></a></li>
						<li><a class="googleplus" href="#"></a></li>
						<li><a class="dribbble" href="#"></a></li>
					</ul>
				</div>
				<div class="clearfix"></div>
			</div>
		</div>
	</div>

templates/share/header.html
{% load static %}
<div class="header">
    <div class="header-top">
        <div class="wrap">
            <div class="top-menu">
                <ul>
                    <li><a href="index.html">صفحه اصلی</a></li>
                    <li><a href="about.html">درباره ما</a></li>
                    <li><a href="privacy-policy.html">سیاست حفظ حریم خصوصی</a></li>
                    <li><a href="contact.html">تماس با ما</a></li>
                </ul>
            </div>
            <div class="num">
                <p>با ما تماس بگیرید : 032 2352 782</p>
            </div>
            <div class="clearfix"></div>
        </div>
    </div>
    <div class="header-bottom">
        <div class="logo text-center">
            <a href="index.html"><img src="images/logo.jpg" alt=""/></a>
        </div>
        <div class="navigation">
            <nav class="navbar navbar-default" role="navigation">
                <div class="wrap">
                    <div class="navbar-header">
                        <button type="button" class="navbar-toggle" data-toggle="collapse"
                                data-target="#bs-example-navbar-collapse-1">
                            <span class="sr-only">تبدیل ناوبری</span>
                            <span class="icon-bar"></span>
                            <span class="icon-bar"></span>
                            <span class="icon-bar"></span>
                        </button>

                    </div>
                    <!--/.navbar-header-->
                    <div class="collapse navbar-collapse" id="bs-example-navbar-collapse-1">
                        <ul class="nav navbar-nav">
                            <li class="active"><a href="{% url "blog:Home" %}">صفحه اصلی</a></li>
                            {% for foo in categores %}
                                {% if foo.parent == None %}
                                    {% if foo.children.all %}
                                        <li class="dropdown">
                                            <a href="#" class="dropdown-toggle" data-toggle="dropdown">{{ foo.name }}<b
                                                    class="caret"></b></a>
                                            <ul class="dropdown-menu">
                                                {% include "share/navbar_loop.html" with categores=foo.children.all %}
                                            </ul>
                                        </li>
                                    {% else %}
                                        <li><a href="sports.html">{{ foo.name }}</a></li>
                                    {% endif %}
                                {% endif %}

                            {% endfor %}
                            <div class="clearfix"></div>
                        </ul>
                        <div class="search">
                            <!-- start search-->
                            <div class="search-box">
                                <div id="sb-search" class="sb-search">
                                    <form>
                                        <input class="sb-search-input" placeholder="عبارت جستجو را وارد کنید..."
                                               type="search" name="search" id="search">
                                        <input class="sb-search-submit" type="submit" value="">
                                        <span class="sb-icon-search"> </span>
                                    </form>
                                </div>
                            </div>
                            <!-- search-scripts -->

                            <script>
                                new UISearch(document.getElementById('sb-search'));
                            </script>
                            <!-- //search-scripts -->
                        </div>
                        <div class="clearfix"></div>
                    </div>
                </div>
                <!--/.navbar-collapse-->
                <!--/.navbar-->
            </nav>
        </div>
    </div>
</div>

templates/share/js.html
{% load static %}

<script src="{% static "js/jquery.min.js" %}"></script>

<script type="application/x-javascript"> addEventListener("load", function() { setTimeout(hideURLbar, 0); }, false); function hideURLbar(){ window.scrollTo(0,1); } </script>

<script type="text/javascript" src="{% static "js/bootstrap.js" %}"></script>

<script src="{% static "js/responsiveslides.min.js" %}"></script>
	<script>
		$(function () {
		  $("#slider").responsiveSlides({
			auto: true,
			nav: true,
			speed: 500,
			namespace: "callbacks",
			pager: true,
		  });
		});
	</script>
	<script type="text/javascript" src="{% static "js/move-top.js" %}"></script>
<script type="text/javascript" src="{% static "js/easing.js" %}"></script>

<script src="{% static "js/classie.js" %}"></script>
<script src="{% static "js/uisearch.js" %}"></script>

<script type="text/javascript" src="{% static "js/jquery.marquee.min.js" %}"></script>


<script type="text/javascript">
			jQuery(document).ready(function($) {
				$(".scroll").click(function(event){
					event.preventDefault();
					$('html,body').animate({scrollTop:$(this.hash).offset().top},900);
				});
			});
</script>

<script type="text/javascript">
		$(document).ready(function() {
				/*
				var defaults = {
				wrapID: 'toTop', // fading element id
				wrapHoverID: 'toTopHover', // fading element hover id
				scrollSpeed: 1200,
				easingType: 'linear'
				};
				*/
		$().UItoTop({ easingType: 'easeOutQuart' });
});
</script>

templates/share/navbar_loop.html
{% for foo in categores %}
        {% if foo.children.all %}
            <li class="dropdown">
                <a href="#" class="dropdown-toggle" data-toggle="dropdown">{{ foo.name }}<b
                        class="caret"></b></a>
                <ul class="dropdown-menu">
                    {% include "share/navbar_loop.html" with categores=foo.children.all %}
                </ul>
            </li>
        {% else %}
            <li><a href="sports.html">{{ foo.name }}</a></li>
        {% endif %}

{% endfor %}

templates/share/slider.html
<div class="slider">
    <div class="callbacks_wrap">
        <ul class="rslides" id="slider">
            <li>
                <img src="images/3.jpg" alt="">
                <div class="caption">
                    <a href="single.html">لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با
                        استفاده از طراحان گرافیک است</a>
                </div>
            </li>
            <li>
                <img src="images/2.jpg" alt="">
                <div class="caption">
                    <a href="single.html">لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با
                        استفاده از طراحان گرافیک است</a>
                </div>
            </li>
            <li>
                <img src="images/1.jpg" alt="">
                <div class="caption">
                    <a href="single.html">لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با
                        استفاده از طراحان گرافیک است</a>
                </div>
            </li>
        </ul>
    </div>
</div>